﻿Imports System.Collections.ObjectModel
Imports DlhSoft.Windows.Data

Module Module1

    Sub Main()

        Console.WriteLine("NodeManager Sample")

        ' Prepare the node data collection.
        Dim nodeItems As New ObservableCollection(Of NodeItem)
        nodeItems.Add(New NodeItem With {.Content = "Node 1"})
        nodeItems.Add(New NodeItem With {.Content = "Node 1.1", .Indentation = 1})
        nodeItems.Add(New NodeItem With {.Content = "Node 1.2", .Indentation = 1})
        nodeItems.Add(New NodeItem With {.Content = "Node 1.2.1", .Indentation = 2})
        nodeItems.Add(New NodeItem With {.Content = "Node 1.2.2", .Indentation = 2})
        nodeItems.Add(New NodeItem With {.Content = "Node 2", .IsExpanded = True})
        nodeItems.Add(New NodeItem With {.Content = "Node 2.1", .Indentation = 1})
        nodeItems.Add(New NodeItem With {.Content = "Node 2.2", .Indentation = 1})
        nodeItems.Add(New NodeItem With {.Content = "Node 2.3", .Indentation = 1, .IsExpanded = True})
        nodeItems.Add(New NodeItem With {.Content = "Node 2.3.1", .Indentation = 2})
        nodeItems.Add(New NodeItem With {.Content = "Node 2.3.2", .Indentation = 2})
        nodeItems.Add(New NodeItem With {.Content = "Node 3"})

        ' You can also prepare node data items dynamically.
        For i As Integer = 4 To 64
            nodeItems.Add(New NodeItem With {.Content = "Node " & i})
        Next

        ' Initialize the NodeManager object using the prepared node data items.
        Dim nodeManager As New NodeManager(nodeItems)

        ' Use the Nodes and other properties of the NodeManager object to access the managed nodes and related information.
        Console.WriteLine("Nodes: Count = {0}", nodeManager.Count)
        For Each node As Node In nodeManager.Nodes
            Console.WriteLine("Nodes[{0}]: Indentation = {1}, IsExpanded = {2}, IsVisible = {3}", node.Index, node.Indentation, node.IsExpanded, node.IsVisible)
        Next

        ' Dispose the NodeManager object when it is no longer needed.
        nodeManager.Dispose()

    End Sub

End Module
